#! /bin/perl

#
# Eric GARREAU, 1997
# BPL (Bob Public License) : register to the Mailing List of this product
# 'Le Petit Bob' at 'egarreau@free.fr'
#

#
# Avis au lecteur : merci d'etre indulgent, c'est mon premier jour de Perl...
#

#
# bon, d'accord : ces fichiers ont evolue, depuis mon premier jour de Perl...
#

# ce script fait :
# - lecture de tous les repertoires non proteges par la directive '.keep'
# - execution du 'make -f $TWSTOOLS/Makefile' dans chaque repertoire
#


# ce script utilise les fichiers suivants :
#
# nom : $TWSFILES/trees_to_browse.[dir,pag]
# type : hash des repertoires "physiques" a scruter, avec leurs chemins
#         equivalents (par rapport a 'http://server/')  et les proprietaires
#         (pour que les fichiers crees leur appartiennent...). Ce hash
#         contient egalement les sous-arborescences a EXCLURE de la
#         scrutation globale (pour ne pas faire exploser les tableaux !)
# usage : recuperation des proprietaires en fonction de l'arborescence
#
# nom : $TWSFILES/megalist_of_dirs
# type : liste de tous les repertoires a traiter
#         (ceux qui ne sont pas proteges par la directive '.keep)
# usage : boucler sur tous les repertoires, et lancer le 'make'
#
#


# ce script genere les fichiers suivants :
#
# nom : $TWSFILES/log_unresolved
# type : liste de tous les fichiers '.html' qui contiennent au moins un lien
#         qui n'a pas pu etre resolu (c'est 'pass3.pl' qui le complete)
# usage : permet a 'try_again_make_html_files' de tenter sa chance...
# format : noms des fichiers '.html'
#
#
# nom : tous les fichiers '.html' plus recents que leurs alter ego '.txt'
# usage : lancer la commande 'make -f $TWSTOOLS/Makefile OWNER=owner'
#



require 5;
use Fcntl;
use ANYDBM_File;;



# la base de l'arborescence Intranet
$TWSROOT=$ENV{"TWSROOT"};
$TWSTOOLS=$ENV{"TWSTOOLS"};
$TWSFILES=$ENV{"TWSFILES"};
die "Variables \$TWS[TOOLS,FILES] non definies --> il faut sourcer '.twsrc'\n" if ($TWSROOT eq '' or $TWSTOOLS eq '' or $TWSFILES eq '');



# niveau de debug, pour les traces 'print XXX if $debug > N'
$debug=0;


# la database des repertoires a traiter
$treeshash="$TWSFILES/list_of_trees";

# les fichiers, planques dans le repertoire '$TWSFILES'
$dirsmegalist = "$TWSFILES/megalist_of_dirs";


# LA commande de Makefile (avec l'option "silence")
$makecommand = "make -f $TWSTOOLS/Makefile";




# la premiere arborescence a parcourir n'existe pas, pour forcer la recherche
# du proprietaire des fichiers a creer
$current_tree = '/lost_and_never_found_again  ?';
$current_owner = 'Roswell_creature';


# 0 = pas de masque de creation
tie(%trees, SDBM_File, $treeshash, O_READONLY, 0) or die "I need a browse database !\n";

# ne conserver que le HASH 'proprietaires{chemins}'
while( ($tree,$value) = each(%trees))
{
    my $equiv, $owner;

    ($equiv, $owner) = split(/\n/, $value);

    next if $equiv eq 'exclude';

    $treeowners{$tree} = $owner;
}
untie(%trees);



# boucler sur tous les repertoires a traiter
open(DIRS, "< $dirsmegalist");
while($dir=<DIRS>)
{
    # NOTE : ne JAMAIS oublier le 'chomp' pour un 'opendir' ou un 'chdir'...
    chomp $dir;

    print "dir=$dir\n" if $debug > 13;

    # aller DANS le repertoire pour y lancer le 'make'
    # ne pas se prendre la tete si par hasard le 'chdir' echoue
    next if ! chdir $dir;

    print "je suis DANS $dir :\n" if $debug > 20;

    # dans quelle arborescence suis-je ? a qui appartient-elle ?
    # avant de lancer la "grosse" recherche, on verifie qu'on est toujours
    # dans la meme arborescence
    unless($dir =~ m|$current_tree|)
    {
	foreach $tree (keys(%treeowners))
	{
	    # la base d'arborescence figure-t-elle dans le chemin complet ?
	    if($dir =~ m|$tree|)
	    {
		print "$dir is in $tree\n" if $debug > 10;
		$current_tree = $tree;
		$current_owner = $treeowners{$tree};
		print "owner is $current_owner\n" if $debug > 10;
	    }
	}
    }
#    else
#    {
#	print "OK : $dir is in $current_tree\n" if $debug > 10;
#    }

    print "$makecommand OWNER=$current_owner\n" if $debug > 12;
    system "$makecommand OWNER=$current_owner";
}


close(DIRS);



